<?php

include("config.php");

// ----------------------------------------------------------------------
// - FUNCTIONS
// ----------------------------------------------------------------------

function xLabelFormat($aLabel) 
{
	global $XFORMAT;
   	return gmdate( $XFORMAT, $aLabel);
}

// ----------------------------------------------------------------------
// - INCLUDES & VARIABLES
// ----------------------------------------------------------------------

require_once($JPGRAPH_PATH."jpgraph.php");
require_once($JPGRAPH_PATH."jpgraph_line.php");
require_once($JPGRAPH_PATH."jpgraph_radar.php");

$timer=new JpgTimer();
$STATS="Generation statistics : ";

$WIDTH1=1000;
$HEIGHT1=200;
$MARGIN_LEFT1=60;
$MARGIN_RIGHT1=250;
$MARGIN_TOP1=40;
$MARGIN_BOTTOM1=10;
$MARGIN_MIDDLE_V1=$HEIGHT1-$MARGIN_TOP1-$MARGIN_BOTTOM1;
$MARGIN_MIDDLE_H1=$WIDTH1-$MARGIN_LEFT1-$MARGIN_RIGHT1;

$WIDTH2=1000;
$HEIGHT2=200;
$MARGIN_LEFT2=60;
$MARGIN_RIGHT2=250;
$MARGIN_TOP2=0;
$MARGIN_BOTTOM2=40;
$MARGIN_MIDDLE_V2=$HEIGHT2-$MARGIN_TOP2-$MARGIN_BOTTOM2;
$MARGIN_MIDDLE_H2=$WIDTH2-$MARGIN_LEFT2-$MARGIN_RIGHT2;

$WIDTH3=1000;
$HEIGHT3=300;
$MARGIN_LEFT3=60;
$MARGIN_RIGHT3=720;
$MARGIN_TOP3=30;
$MARGIN_BOTTOM3=30;

$LEGENDX1=$MARGIN_LEFT1+$MARGIN_MIDDLE_H1+80;
$LEGENDY1=$MARGIN_TOP1+5;
$LEGEND_WIDTH1=157;
$LEGEND_HEIGHT1=81;
$LEGEND_POSX1=560;
$LEGEND_POSY1=455;

$LEGENDX2=$MARGIN_LEFT2+$MARGIN_MIDDLE_H2+80;
$LEGENDY2=$MARGIN_TOP2+5;
$LEGEND_WIDTH2=124;
$LEGEND_HEIGHT2=36;
$LEGEND_POSX2=$LEGEND_POSX1;		// don't touch !!
$LEGEND_POSY2=$LEGEND_POSY1+80;		// don't touch !!

$INFOX1=$WIDTH3-$MARGIN_RIGHT3+50;
$INFOY1=$MARGIN_TOP3;

$INFOX2=$INFOX1+220;
$INFOY2=$INFOY1;

$INFOX3=$INFOX2;
$INFOY3=$INFOY1+170;

$hour_number=($_GET['stop']-$_GET['start'])/3600;
$ticks_number=($WIDTH1-$MARGIN_LEFT1-$MARGIN_RIGHT1)/40; //inter tick 40px

if ($hour_number<96 ) 
{
	$hour_number=($_GET['stop']-$_GET['start'])/3600;
	$XTICK_INTERVAL=ceil($hour_number/$ticks_number)*3600;
	$XFORMAT="H\hi\nd/m";
}
else if ($hour_number>=96 ) 
{
	$ticks=($_GET['stop']-$_GET['start'])/86400;
	$XTICK_INTERVAL=ceil($ticks/$ticks_number)*86400;
	$XFORMAT="d/m";
}


// ----------------------------------------------------------------------
// - SQL REQUEST
// ----------------------------------------------------------------------

$timer->Push();

mysql_connect($MYSQL_SERVER, $MYSQL_USER, $MYSQL_PASSWORD) or die("MYSQL error : ".mysql_error());
mysql_select_db($MYSQL_DATABASE) or die("MYSQL error : ".mysql_error());

switch($MYSQL_TIMESTAMP)
{
	case 0 :
		$StartDate=$_GET['start'];
		$StopDate=$_GET['stop'];
		break;
	default: case 1:
		$StartDate=strftime("%Y%m%d%H%M%S",$_GET['start']);
		$StopDate=strftime("%Y%m%d%H%M%S",$_GET['stop']);	
		break;
}
$sql="SELECT `";
$sql.=$MYSQL_FIELD['absolute_pressure']."`,`";
$sql.=$MYSQL_FIELD['outdoor_humidity']."`,`";
$sql.=$MYSQL_FIELD['outdoor_temperature']."`,`";
$sql.=$MYSQL_FIELD['dew_point']."`,`";
$sql.=$MYSQL_FIELD['wind_chill']."`,`";
$sql.=$MYSQL_FIELD['wind_direction']."`,`";
$sql.=$MYSQL_FIELD['wind_speed']."`,`";
$sql.=$MYSQL_FIELD['total_rainfall']."`,`";
$sql.=$MYSQL_FIELD['timestamp']."`";
$sql.=" FROM ".$MYSQL_TABLE." WHERE ".$MYSQL_FIELD['timestamp']."<='".$StopDate."' AND ".$MYSQL_FIELD['timestamp'].">='".$StartDate."'";
$query=mysql_query($sql) or die ("MYSQL error : ".mysql_error());


for ($i=0;$i<16;$i++) $count[$i]=0;
$i=0;
while ($list=mysql_fetch_array($query))
{
	$y1data[$i]=$list[0];
	$y2data[$i]=$list[1];
	$y3data[$i]=$list[2];
	$y4data[$i]=$list[3];
	$y5data[$i]=$list[4];
	$count[$list[5]/22.5]++;
	$y6data[$i]=$list[6];
	$y7data[$i]=$list[7];
		switch($MYSQL_TIMESTAMP)
	{
		case 0 :
			$timestamp[$i]=$list[8];
			break;
		default: case 1:
			sscanf($list[8],"%4d%2d%2d%2d%2d%2d",$a_year,$a_month,$a_day,$a_hours,$a_minutes,$a_seconds);
			$timestamp[$i]=intval(mktime($a_hours,$a_minutes,$a_seconds,$a_month,$a_day,$a_year,-1));
			break;
	}
	$i++;
}


print_r ($query);
$y1max=max($y1data);
$y2max=max($y2data);
$y3max=max($y3data);
$y4max=max($y4data);
$y5max=max($y5data);
$y6max=max($y6data);
$YMAX=max($y3max,$y4max,$y5max);

$y1min=min($y1data);
$y2min=min($y2data);
$y3min=min($y3data);
$y4min=min($y4data);
$y5min=min($y5data);
$YMIN=min($y3min,$y4min,$y5min);

$YMAX=round($YMAX+($YMAX-$YMIN)*0.1);
$YMIN=round($YMIN-($YMAX-$YMIN)*0.1);

$ticks_number=($HEIGHT1-$MARGIN_TOP1-$MARGIN_BOTTOM1)/20; //inter tick 40px
$YTICK_INTERVAL=round(($YMAX-$YMIN)/$ticks_number); 

for($i=0;$i<count($y2data);$i++)
{
	$y2data[$i]=$y2data[$i]*($YMAX-$YMIN)/100+$YMIN;
}


$total_rainfall=$y7data[count($y7data)-1]-$y7data[0];
for($i=0;$i<count($y7data)-1;$i++)
{
	$y7data[$i]=$y7data[$i+1]-$y7data[$i];
}
$y7data[count($y7data)-1]=$y7data[count($y7data)-2]; //last value


$STATS.="sql=".($timer->Pop()/1000)."s ";

// ----------------------------------------------------------------------
// - FORMAT INFOS
// ----------------------------------------------------------------------

$timer->Push();

if ($FREE_SERVER)
$char_width=sprintf("                                                         \n");
else	
$char_width=sprintf("                                                               \n");


$MINMAX=sprintf("               .::: Min and Max :::.\n");
$MINMAX.=$char_width;
$MINMAX.= sprintf("Pressure : %.1f / %.1f hPa\n",$y1min,$y1max);
$MINMAX.=sprintf("Humidity : %d / %d \n",$y2min,$y2max);
$MINMAX.=sprintf("Temperature : %.1f / %.1f C\n",$y3min,$y3max);
$MINMAX.=sprintf("Dew Point : %.1f / %.1f C\n",$y4min,$y4max);
$MINMAX.=sprintf("WindChill : %.1f / %.1f C\n",$y5min,$y5max);
$MINMAX.=sprintf("Max Wind Speed : %.1f km/h\n",$y6max);
$MINMAX.=sprintf("Total Rainfall : %.1f mm\n",$total_rainfall);

if ($FREE_SERVER) 
$MINMAX.=sprintf("\n \n \n \n \n \n");					

$DB_INFOS=sprintf("          .::: Database Statistics :::.\n");
$DB_INFOS.=$char_width;
$DB_INFOS.=sprintf("Database : %s\n\n",$MYSQL_DATABASE);
$DB_INFOS.=sprintf("Measures : %d",count($timestamp));

if ($FREE_SERVER)
$DB_INFOS.=sprintf("\n \n ");				
		
$LEGEND=sprintf("                      .::: Legend :::.\n");
$LEGEND.=$char_width;
if ($FREE_SERVER)
$LEGEND.=sprintf("\n \n \n \n \n \n \n \n \n \n \n");	
else
$LEGEND.=sprintf("\n \n \n \n \n \n \n");

$minmax=new  Text($MINMAX);
$minmax->SetFont(FF_COMIC,FS_NORMAL,8);
//$minmax->Pos($INFOX1,$INFOY1,'left','top');
$minmax->SetBox($BACKGROUND_COLOR,'black',true,5,3); 

$db_infos=new  Text($DB_INFOS);
$db_infos->SetFont(FF_COMIC,FS_NORMAL,8);
//$db_infos->Pos($INFOX3,$INFOY3,'left','top');
$db_infos->SetBox($BACKGROUND_COLOR,'black',true,5,3); 

$legend=new Text($LEGEND);
$legend->SetFont(FF_COMIC,FS_NORMAL,8);
//$legend->Pos($INFOX2,$INFOY2,'left','top');
$legend->SetBox($BACKGROUND_COLOR,'black',true,5,3); 


// ----------------------------------------------------------------------
// - GLOBAL GRAPH
// ----------------------------------------------------------------------

$graph = new Graph($WIDTH1,$HEIGHT1);
$graph->SetScale("linlin",$YMIN,$YMAX,$_GET['start'],$_GET['stop']);
$graph->SetY2Scale("lin");
$graph->SetMargin($MARGIN_LEFT1,$MARGIN_RIGHT1,$MARGIN_TOP1,$MARGIN_BOTTOM1);
$graph->SetMarginColor($BACKGROUND_COLOR);
$graph->SetFrame(true,'black',0);
$graph->title->SetFont(FF_COMIC,FS_NORMAL,12);
$graph->title->SetMargin(10);
$graph->title->Set($GRAPH_TITLE);
$graph->legend->SetAbsPos($LEGENDX1,$LEGENDY1,'left','top');
$graph->legend->SetFont(FF_COMIC,FS_NORMAL,8);
$graph->legend->SetFillColor($BACKGROUND_COLOR); 
$graph->legend->SetFrameWeight(1);

$graph->xaxis->HideLabels() ;
//$graph->xaxis->SetLabelFormatCallback('xLabelFormat'); 
//$graph->xaxis->SetFont(FF_COMIC,FS_NORMAL,8); 
$graph->xaxis->SetTextLabelInterval(1);
$graph->xscale->ticks->Set($XTICK_INTERVAL,0);
$graph->xscale->ticks->SupressMinorTickMarks();
$graph->xscale->ticks->SupressTickMarks();
$graph->xaxis->SetPos('min');
$graph->xgrid->Show(true ,true);

$graph->yaxis->HideFirstTicklabel() ;
$graph->yaxis->SetFont(FF_COMIC,FS_NORMAL,8); 
$graph->yaxis->title->SetFont(FF_COMIC,FS_NORMAL,10);
$graph->yaxis->title->Set("Temperature (C)");
$graph->yaxis->title->SetMargin(10);
$graph->yaxis->SetTextLabelInterval(1);
$graph->yscale->ticks->Set($YTICK_INTERVAL+1,1);
$graph->ygrid->Show(true ,false);

$graph->y2axis->HideFirstTicklabel();
$graph->y2axis->SetPos('max');
$graph->y2axis->SetFont(FF_COMIC,FS_NORMAL,8); 
$graph->y2axis->title->SetFont(FF_COMIC,FS_NORMAL,10);
$graph->y2axis->title->Set("Pressure (hPa)");
$graph->y2axis->title->SetMargin(20);
$graph->y2axis->SetTitleSide(SIDE_RIGHT);

$lplot1 = new LinePlot($y1data,$timestamp);
$lplot1->SetColor('red');
$lplot1->SetLegend("Pressure (hPA)");

$lplot2 = new LinePlot($y2data,$timestamp);
$lplot2->SetFillFromYMin(); 
$lplot2->SetColor('blue@0.8');
$lplot2->SetFillGradient('blue@0.7','blue@1',30); 
$lplot2->SetFillColor('blue@0.8');
$lplot2->SetLegend("Humidity (%)");

$lplot3 = new LinePlot($y3data,$timestamp);
$lplot3->SetColor('blue');
$lplot3->SetLegend("Outdoor Temperature (C)");

$lplot4 = new LinePlot($y4data,$timestamp);
$lplot4->SetColor('seagreen3');
$lplot4->SetLegend("Dew Point (C)");

$lplot5 = new LinePlot($y5data,$timestamp);
$lplot5->SetColor('royalblue4');
$lplot5->SetLegend("WindChill (C)");

$graph->Add($lplot5); //first ensure that outdoor temp is draw above when temp >5C
$graph->Add($lplot2);
$graph->Add($lplot3);
$graph->Add($lplot4);
$graph->AddY2($lplot1);

$handle = $graph->Stroke( _IMG_HANDLER);

// ----------------------------------------------------------------------
// - GRAPH2
// ----------------------------------------------------------------------

$graph2 = new Graph($WIDTH2,$HEIGHT2);
$graph2->SetScale("linlin",1,1,$_GET['start'],$_GET['stop']);
$graph2->SetY2Scale("lin");
$graph2->SetFrame(true,'black',0); 
$graph2->SetMargin($MARGIN_LEFT2,$MARGIN_RIGHT2,$MARGIN_TOP2,$MARGIN_BOTTOM2);
$graph2->SetMarginColor($BACKGROUND_COLOR);
$graph2->title->SetFont(FF_COMIC,FS_NORMAL,12);
$graph2->title->SetMargin(10);
$graph2->legend->SetAbsPos($LEGENDX2,$LEGENDY2,'left','top');
$graph2->legend->SetFont(FF_COMIC,FS_NORMAL,8);
$graph2->legend->SetFillColor($BACKGROUND_COLOR); 
$graph2->legend->SetShadow(false); 

$graph2->xaxis->SetLabelFormatCallback('xLabelFormat'); 
$graph2->xaxis->SetFont(FF_COMIC,FS_NORMAL,8); 
$graph2->xaxis->SetTextLabelInterval(1);
$graph2->xscale->ticks->Set($XTICK_INTERVAL,0);
$graph2->xgrid->Show(true ,true);

$graph2->yaxis->HideFirstTicklabel() ;
$graph2->yaxis->HideLastTicklabel() ;
$graph2->yaxis->SetFont(FF_COMIC,FS_NORMAL,8); 
$graph2->yaxis->title->SetFont(FF_COMIC,FS_NORMAL,10);
$graph2->yaxis->title->Set("Wind speed (km/h)");
$graph2->yaxis->title->SetMargin(10);
$graph2->yaxis->SetTextLabelInterval(1);
$graph2->yscale->ticks->Set($YTICK_INTERVAL+1,1);
$graph2->ygrid->Show(true ,false);

$graph2->y2axis->HideFirstTicklabel();
$graph2->y2axis->HideLastTicklabel();
$graph2->y2axis->SetPos('max');
$graph2->y2axis->SetFont(FF_COMIC,FS_NORMAL,8); 
$graph2->y2axis->title->SetFont(FF_COMIC,FS_NORMAL,10);
$graph2->y2axis->title->Set("Rainfall (mm)");
$graph2->y2axis->title->SetMargin(20);
$graph2->y2axis->SetTitleSide(SIDE_RIGHT);

$lplot6 = new LinePlot($y6data,$timestamp);
$lplot6->SetColor('red@0.8');
$lplot6->SetFillColor('red@0.7');
$lplot6->SetFillGradient('red@0.4','red@0.9',30); 
$lplot6->SetLegend("Wind Speed (km/h)");

$lplot7 = new LinePlot($y7data,$timestamp);
$lplot7->SetColor('blue@0.8');
$lplot7->SetFillColor('blue@0.7');
$lplot7->SetFillGradient('blue@0.4','blue@0.9',30); 
$lplot7->SetLegend("Rainfall (mm)");

$graph2->AddY2($lplot7);
$graph2->Add($lplot6); 

$handle2 = $graph2->Stroke(_IMG_HANDLER);

// ----------------------------------------------------------------------
// - GRAPH3 : PREVAILING WIND
// ----------------------------------------------------------------------

// Reverse values
$new_count[0]=$count[0];
for ($i=1;$i<16;$i++)
{
	$new_count[$i]=$count[16-$i];
}

$graph3 = new RadarGraph($WIDTH3,$HEIGHT3,"auto");
$graph3->SetCenter(0.17,0.5);

$graph3->SetColor($BACKGROUND_COLOR);
$graph3->SetMargin($MARGIN_LEFT3,$MARGIN_RIGHT3,$MARGIN_TOP3,$MARGIN_BOTTOM3);
$graph3->title->SetFont(FF_COMIC,FS_NORMAL,11);
$graph3->title->Set("                             Prevailing wind");
$graph3->title->SetAlign("left");
$graph3->axis->SetFont(FF_COMIC,FS_NORMAL,8);
$graph3->axis->title->SetFont(FF_COMIC,FS_NORMAL,8);
$graph3->SetFrame(true,'black',0);
$graph3->SetTitles(array("N","NN0","N0","0N0","0","0S0","S0","SS0","S","SSE","SE","ESE","E","ENE","NE","NNE","N"));
$graph3->grid->Show ();
$graph3->grid-> SetLineStyle( "solid");

$polar = new RadarPlot($new_count);
$polar->SetFillColor('blue@0.8');
$polar->SetColor('blue@0.6');
$graph3->Add($polar);
$graph3->AddText($minmax);
$graph3->AddText($db_infos);
$graph3->AddText($legend);

$handle3 = $graph3->Stroke(_IMG_HANDLER);

$STATS.="graph=".($timer->Pop()/1000)."s ";

// ----------------------------------------------------------------------
// - MELTED GRAPHS
// ----------------------------------------------------------------------

$timer->Push();

$image=imagecreatetruecolor($WIDTH1-170,$HEIGHT1+$HEIGHT2+$HEIGHT3);

imagecopy($image, $handle,0, 0, 0, 0, $WIDTH1,$HEIGHT1);
imagecopy($image, $handle2,0,$HEIGHT1,0, 0,$WIDTH2,$HEIGHT2);
imagecopy($image, $handle3,0,$HEIGHT1+$HEIGHT2,0,0,$WIDTH3,$HEIGHT3);

imagecopy($image, $handle,$LEGEND_POSX1,$LEGEND_POSY1,$LEGENDX1+1,$LEGENDY1+1,$LEGEND_WIDTH1,$LEGEND_HEIGHT1);
imagecopy($image, $handle2,$LEGEND_POSX2,$LEGEND_POSY2,$LEGENDX2+1,$LEGENDY2+1,$LEGEND_WIDTH2,$LEGEND_HEIGHT2);

$STATS.="merge=".($timer->Pop()/1000)."s ";
$black = imagecolorallocate($image, 0, 0, 0);
imagettftext($image, 8, 0,10, $HEIGHT1+$HEIGHT2+$HEIGHT3-5,$black,"comic.ttf" ,$STATS);
header("Content-type: image/png");
imagepng ($image);
ImageDestroy($image);
mysql(close);
?>